Ruby Client for the Cloud Bigtable Admin V2 API

API Client library for the Cloud Bigtable Admin V2 API

Cloud Bigtable is a fully managed, scalable NoSQL database service for large analytical and operational workloads.

https://github.com/googleapis/google-cloud-ruby

This gem is a versioned client. It provides basic client classes for a specific version of the Cloud Bigtable Admin V2 API. Most users should consider using the main client gem, google-cloud-bigtable. See the section below titled Which client should I use? for more information.

Installation

$ gem install google-cloud-bigtable-admin-v2

Before You Begin

In order to use this library, you first need to go through the following steps:

  1. Select or create a Cloud Platform project.
  2. Enable billing for your project.
  3. Enable the API.
  4. Set up authentication.

Quick Start

require "google/cloud/bigtable/admin/v2"

client = ::Google::Cloud::Bigtable::Admin::V2::BigtableInstanceAdmin::Client.new
request = ::Google::Cloud::Bigtable::Admin::V2::CreateInstanceRequest.new # (request fields as keyword arguments...)
response = client.create_instance request

View the Client Library Documentation for class and method documentation.

See also the Product Documentation for general usage information.

Enabling Logging

To enable logging for this library, set the logger for the underlying gRPC library. The logger that you set may be a Ruby stdlib Logger as shown below, or a Google::Cloud::Logging::Logger that will write logs to Cloud Logging. See grpc/logconfig.rb and the gRPC spec_helper.rb for additional information.

Configuring a Ruby stdlib logger:

require "logger"

module MyLogger
  LOGGER = Logger.new $stderr, level: Logger::WARN
  def logger
    LOGGER
  end
end

# Define a gRPC module-level logger method before grpc/logconfig.rb loads.
module GRPC
  extend MyLogger
end

Supported Ruby Versions

This library is supported on Ruby 2.5+.

Google provides official support for Ruby versions that are actively supported by Ruby Core—that is, Ruby versions that are either in normal maintenance or in security maintenance, and not end of life. Currently, this means Ruby 2.5 and later. Older versions of Ruby may still work, but are unsupported and not recommended. See https://www.ruby-lang.org/en/downloads/branches/ for details about the Ruby support schedule.

Which client should I use?

Most modern Ruby client libraries for Google APIs come in two flavors: the main client library with a name such as google-cloud-bigtable, and lower-level versioned client libraries with names such as google-cloud-bigtable-admin-v2. In most cases, you should install the main client.

What's the difference between the main client and a versioned client?

A versioned client provides a basic set of data types and client classes for a single version of a specific service. (That is, for a service with multiple versions, there might be a separate versioned client for each service version.) Most versioned clients are written and maintained by a code generator.

The main client is designed to provide you with the recommended client interfaces for the service. There will be only one main client for any given service, even a service with multiple versions. The main client includes factory methods for constructing the client objects we recommend for most users. In some cases, those will be classes provided by an underlying versioned client; in other cases, they will be handwritten higher-level client objects with additional capabilities, convenience methods, or best practices built in. Generally, the main client will default to a recommended service version, although in some cases you can override this if you need to talk to a specific service version.

Why would I want to use the main client?

We recommend that most users install the main client gem for a service. You can identify this gem as the one without a version in its name, e.g. google-cloud-bigtable. The main client is recommended because it will embody the best practices for accessing the service, and may also provide more convenient interfaces or tighter integration into frameworks and third-party libraries. In addition, the documentation and samples published by Google will generally demonstrate use of the main client.

Why would I want to use a versioned client?

You can use a versioned client if you are content with a possibly lower-level class interface, you explicitly want to avoid features provided by the main client, or you want to access a specific service version not be covered by the main client. You can identify versioned client gems because the service version is part of the name, e.g. google-cloud-bigtable-admin-v2.

What about the google-apis- clients?

Client library gems with names that begin with google-apis- are based on an older code generation technology. They talk to a REST/JSON backend (whereas most modern clients talk to a gRPC backend) and they may not offer the same performance, features, and ease of use provided by more modern clients.

The google-apis- clients have wide coverage across Google services, so you might need to use one if there is no modern client available for the service. However, if a modern client is available, we generally recommend it over the older google-apis- clients.